//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  DarkGray
#property indicator_style2  STYLE_DOT
#property indicator_width1  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int    FastEmaPeriod       = 12;
extern int    SlowEmaPeriod       = 26;
extern int    SignalEmaPeriod     =  9;
extern bool   AdjustSignal        = true;
extern int    Price               = PRICE_CLOSE;
extern int    VolatilityPeriod    =  5;
extern int    VolatilitySmooth    = 10;
extern bool   arrowsVisible       = false;
extern bool   arrowsOnSignalCross = false;
extern string arrowsIdentifier    = "VAMacdArrows";
extern color  arrowsUpColor       = DeepSkyBlue;
extern color  arrowsDnColor       = Red;
extern double arrowsGap           = 0.75;

double macd[];
double signal[];
double price[];
double sum[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,macd);
      SetIndexBuffer(1,signal);
      SetIndexBuffer(2,price);
      SetIndexBuffer(3,sum);
      SetIndexBuffer(4,trend);
   return(0);
}

//
//
//
//
//

int deinit()
{
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);if (StringFind(objectName,arrowsIdentifier) == 0) ObjectDelete(objectName);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][3];
#define _emaf 0
#define _emas 1
#define _emar 2

int start()
{
   int i,r,k,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
    
      for(i = limit, r = Bars-i-1; i >= 0; i--, r++)
      {
         price[i]   =  iMA(NULL,0,1,0,MODE_SMA,Price,i);
         sum[i]     =  0;      for (k = 0; k<VolatilityPeriod; k++) sum[i] += MathAbs(price[i+k]-price[i+k+1]);
         double avg =  sum[i]; for (k = 1; k<VolatilitySmooth; k++) avg    += sum[i+k];
                avg /= VolatilitySmooth;
         
         //
         //
         //
         //
         //
                
            double fastPer = FastEmaPeriod;
            double slowPer = SlowEmaPeriod;
            double signPer = SignalEmaPeriod;
            if (avg!=0 && sum[i]!=0)
            {
                                 fastPer = MathMax(FastEmaPeriod  /(sum[i]/avg),FastEmaPeriod  /2.0);
                                 slowPer = MathMax(SlowEmaPeriod  /(sum[i]/avg),FastEmaPeriod  /2.0);
               if (AdjustSignal) signPer = MathMax(SignalEmaPeriod/(sum[i]/avg),SignalEmaPeriod/2.0);
            }
            double alphaf = 2.0/(1.0+fastPer);
            double alphas = 2.0/(1.0+slowPer);
            double alphar = 2.0/(1.0+signPer);
                
            work[r][_emaf] = work[r-1][_emaf]+alphaf*(price[i]                     -work[r-1][_emaf]);
            work[r][_emas] = work[r-1][_emas]+alphas*(price[i]                     -work[r-1][_emas]);
            work[r][_emar] = work[r-1][_emar]+alphar*(work[r][_emaf]-work[r][_emas]-work[r-1][_emar]);
            
         
         //
         //
         //
         //
         //
         
         trend[i] = trend[i+1];
         macd[i]  = work[r][_emaf]-work[r][_emas];
            if (SignalEmaPeriod>1)
            {
               signal[i] = work[r][_emar];
            }               
            if (arrowsOnSignalCross)
            {
               if (macd[i]>signal[i]) trend[i] =  1;
               if (macd[i]<signal[i]) trend[i] = -1;
            }
            else
            {
               if (macd[i]>0) trend[i] =  1;
               if (macd[i]<0) trend[i] = -1;
            }
         manageArrow(i);
      }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible )
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,241,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,242,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = arrowsGap*iATR(NULL,0,20,i);
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}